////////////////////////////////////////////////////////////////////////////
// PAXScript Importing
// Author: Alexander Baranovsky (ab@cable.netlux.org)
// ========================================================================
// Copyright (c) Alexander Baranovsky, 2003. All rights reserved.                                  
// Code Version: 1.5
// ========================================================================
// Unit: IMP_ExtCtrls.pas
// ========================================================================
////////////////////////////////////////////////////////////////////////////

// Imports classes:
//
//   TBevel
//   TControlBar
//   TCustomControlBar
//   TCustomPanel
//   TCustomRadioGroup
//   THeader
//   TImage
//   TNotebook
//   TPage
//   TPaintBox
//   TPanel
//   TRadioGroup
//   TShape
//   TSplitter
//   TTimer

unit IMP_ExtCtrls;

interface

uses
{$IFDEF LINUX}
  QExtCtrls,
  QGraphics,
{$ELSE}
  ExtCtrls,
  Graphics,
{$ENDIF}
  PaxScripter;

implementation

//--TImage----------------------------------------------------------------------

function TImage_GetCanvas: TCanvas;
begin
 result := TImage(_Self).Canvas;
end;

{TCustomControlBar}
function TCustomControlBar_GetPicture: TPicture;
begin
 result := TCustomControlBar(_Self).Picture;
end;

procedure TCustomControlBar_SetPicture(const Value: TPicture);
begin
 TCustomControlBar(_Self).Picture := Value;
end;

var
  H: Integer;
initialization

  H := RegisterNamespace('ExtCtrls');

//---- TShape ---------------------------------------------------

  RegisterClassType(TShape, H);
  RegisterMethod(TShape, 'constructor Create(AOwner: TComponent); override;',
                @TShape.Create);

//---- TPaintBox ------------------------------------------------

  RegisterClassType(TPaintBox, H);
  RegisterMethod(TPaintBox, 'constructor Create(AOwner: TComponent); override;',
                @TPaintBox.Create);

//---- TImage----------------------------------------------------

  RegisterClassType(TImage, H);
  RegisterMethod(TImage, 'constructor Create(AOwner: TComponent); override;',
                @TImage.Create);
  RegisterMethod(TImage, 'function GetCanvas: TCanvas;',
                @TImage_GetCanvas, Fake);
  RegisterProperty(TImage, 'property Canvas: TCanvas read GetCanvas;');

//---- TBevel ---------------------------------------------------

  RegisterClassType(TBevel, H);
  RegisterMethod(TBevel, 'constructor Create(AOwner: TComponent); override;',
                @TBevel.Create);

//---- TTimer ---------------------------------------------------

  RegisterClassType(TTimer, H);
  RegisterMethod(TTimer, 'constructor Create(AOwner: TComponent); override;',
                @TTimer.Create);

//---- TCustomPanel ---------------------------------------------

  RegisterClassType(TCustomPanel, H);
  RegisterMethod(TCustomPanel, 'constructor Create(AOwner: TComponent); override;',
                @TCustomPanel.Create);

//---- TPanel ---------------------------------------------------

  RegisterClassType(TPanel, H);
  RegisterMethod(TPanel, 'constructor Create(AOwner: TComponent); override;',
                @TPanel.Create);

{$IFDEF WIN32}
//---- TPage ----------------------------------------------------

  RegisterClassType(TPage, H);
  RegisterMethod(TPage, 'constructor Create(AOwner: TComponent); override;',
                @TPage.Create);

//---- TNotebook ------------------------------------------------

  RegisterClassType(TNotebook, H);
  RegisterMethod(TNotebook, 'constructor Create(AOwner: TComponent); override;',
                @TNotebook.Create);

//---- THeader --------------------------------------------------

  RegisterClassType(THeader, H);
  RegisterMethod(THeader, 'constructor Create(AOwner: TComponent); override;',
                @THeader.Create);
{$ENDIF}

//---- TCustomRadioGroup ----------------------------------------

  RegisterClassType(TCustomRadioGroup, H);
  RegisterMethod(TCustomRadioGroup, 'constructor Create(AOwner: TComponent); override;',
                @TCustomRadioGroup.Create);
  RegisterMethod(TCustomRadioGroup, 'procedure FlipChildren(AllLevels: Boolean); override;',
                @TCustomRadioGroup.FlipChildren);

//---- TRadioGroup ----------------------------------------------

  RegisterClassType(TRadioGroup, H);
  RegisterMethod(TRadioGroup, 'constructor Create(AOwner: TComponent); override;',
                @TRadioGroup.Create);

//---- TSplitter ------------------------------------------------

  RegisterClassType(TSplitter, H);
  RegisterMethod(TSplitter, 'constructor Create(AOwner: TComponent); override;',
                @TSplitter.Create);

//---- TCustomControlBar ----------------------------------------

  RegisterClassType(TCustomControlBar, H);
  RegisterMethod(TCustomControlBar, 'constructor Create(AOwner: TComponent); override;',
                @TCustomControlBar.Create);
  RegisterMethod(TCustomControlBar, 'procedure FlipChildren(AllLevels: Boolean); override;',
                @TCustomControlBar.FlipChildren);
  RegisterMethod(TCustomControlBar, 'procedure StickControls;',
                @TCustomControlBar.StickControls);
  RegisterMethod(TCustomControlBar, 'function GetPicture: TPicture;',
                @TCustomControlBar_GetPicture, Fake);
  RegisterMethod(TCustomControlBar, 'procedure SetPicture(const Value: TPicture);',
                @TCustomControlBar_SetPicture, Fake);
  RegisterProperty(TCustomControlBar, 'property Picture: TPicture read'
                +' GetPicture write SetPicture;');

//---- TControlBar ----------------------------------------------

  RegisterClassType(TControlBar, H);
  RegisterMethod(TControlBar, 'constructor Create(AOwner: TComponent); override;',
                @TControlBar.Create);
end.

