////////////////////////////////////////////////////////////////////////////
// PAXScript Importing
// Author: Alexander Baranovsky (ab@cable.netlux.org)
// ========================================================================
// Copyright (c) Alexander Baranovsky, 2003. All rights reserved.                                  
// Code Version: 1.5
// ========================================================================
// Unit: IMP_ImgList.pas
// ========================================================================
////////////////////////////////////////////////////////////////////////////

// Imports classes:
//   TChangeLink,
//   TCustomImageList

unit IMP_ImgList;
interface

uses
  SysUtils,
  Classes,
{$IFDEF LINUX}
  Types,
  QGraphics,
  QImgList,
{$ELSE}
  Graphics,
  ImgList,
{$ENDIF}
  PaxScripter;

implementation

//-------TChangeLink------------------------------------------------------------

function TChangeLink_GetSender: TCustomImageList;
begin
 result := TChangeLink(_Self).Sender;
end;

procedure TChangeLink_SetSender(Value: TCustomImageList);
begin
 TChangeLink(_Self).Sender := Value;
end;

//-------TCustomImageList-------------------------------------------------------

function TCustomImageList_GetCount: Integer;
begin
 result := TCustomImageList(_Self).Count;
end;

function TCustomImageList_GetBkColor: TColor;
begin
 result := TCustomImageList(_Self).BkColor;
end;

procedure TCustomImageList_SetBkColor(Value: TColor);
begin
 TCustomImageList(_Self).BkColor := Value;
end;

function TCustomImageList_GetHeight: Integer;
begin
 result := TCustomImageList(_Self).Height;
end;

procedure TCustomImageList_SetHeight(Value: Integer);
begin
 TCustomImageList(_Self).Height := Value;
end;

function TCustomImageList_GetWidth: Integer;
begin
 result := TCustomImageList(_Self).Width;
end;

procedure TCustomImageList_SetWidth(Value: Integer);
begin
 TCustomImageList(_Self).Width := Value;
end;

var
  H: Integer;

initialization

  H := RegisterNamespace('ImgList');

//---- TChangeLink -------------------------------------------------------------

  RegisterClassType(TChangeLink, H);
  RegisterMethod(TChangeLink, 'constructor Create;',
                 @TChangeLink.Create);
  RegisterMethod(TChangeLink, 'procedure Change; dynamic;',
                @TChangeLink.Change);
  RegisterMethod(TChangeLink, 'function GetSender: TCustomImageList;',
                @TChangeLink_GetSender, Fake);
  RegisterMethod(TChangeLink, 'procedure SetSender(Value: TCustomImageList);',
                @TChangeLink_SetSender, Fake);
  RegisterProperty(TChangeLink, 'property Sender: TCustomImageList read GetSender'
                +' write SetSender;');

//---- TCustomImageList --------------------------------------------------------

  RegisterClassType(TCustomImageList, H);
  RegisterMethod(TCustomImageList, 'constructor Create(AOwner: TComponent); override;',
                @TCustomImageList.Create);
  RegisterMethod(TCustomImageList, 'constructor CreateSize(AWidth, AHeight: Integer);',
                @TCustomImageList.CreateSize);
  RegisterMethod(TCustomImageList, 'procedure Assign(Source: TPersistent); override;',
                @TCustomImageList.Assign);
  RegisterMethod(TCustomImageList, 'function Add(Image, Mask: TBitmap): Integer;',
                @TCustomImageList.Add);
  RegisterMethod(TCustomImageList, 'procedure AddImages(Value: TCustomImageList);',
                @TCustomImageList.AddImages);
  RegisterMethod(TCustomImageList, 'function AddMasked(Image: TBitmap; MaskColor: TColor): Integer;',
                @TCustomImageList.AddMasked);
  RegisterMethod(TCustomImageList, 'procedure Clear;',
                @TCustomImageList.Clear);
  RegisterMethod(TCustomImageList, 'procedure Delete(Index: Integer);',
                @TCustomImageList.Delete);
  RegisterMethod(TCustomImageList, 'procedure GetBitmap(Index: Integer; Image: TBitmap);',
                @TCustomImageList.GetBitmap);
  RegisterMethod(TCustomImageList, 'procedure Insert(Index: Integer; Image, Mask: TBitmap);',
                @TCustomImageList.Insert);
  RegisterMethod(TCustomImageList, 'procedure InsertMasked(Index: Integer; Image: TBitmap; MaskColor: TColor);',
                @TCustomImageList.InsertMasked);
  RegisterMethod(TCustomImageList, 'procedure Move(CurIndex, NewIndex: Integer);',
                @TCustomImageList.Move);
  RegisterMethod(TCustomImageList, 'procedure RegisterChanges(Value: TChangeLink);',
                @TCustomImageList.RegisterChanges);
  RegisterMethod(TCustomImageList, 'procedure Replace(Index: Integer; Image, Mask: TBitmap);',
                @TCustomImageList.Replace);
  RegisterMethod(TCustomImageList, 'procedure ReplaceMasked(Index: Integer; NewImage: TBitmap; MaskColor: TColor);',
                @TCustomImageList.ReplaceMasked);
  RegisterMethod(TCustomImageList, 'procedure UnRegisterChanges(Value: TChangeLink);',
                @TCustomImageList.UnRegisterChanges);
  RegisterMethod(TCustomImageList, 'function GetCount: Integer;',
                @TCustomImageList_GetCount, Fake);
  RegisterProperty(TCustomImageList, 'property Count: Integer read GetCount;');
  RegisterMethod(TCustomImageList, 'function GetBkColor: TColor;',
                @TCustomImageList_GetBkColor, Fake);
  RegisterMethod(TCustomImageList, 'procedure SetBkColor(Value: TColor);',
                @TCustomImageList_SetBkColor, Fake);
  RegisterProperty(TCustomImageList, 'property BkColor: TColor read GetBkColor'
                +' write SetBkColor;');
  RegisterMethod(TCustomImageList, 'function GetHeight: Integer;',
                @TCustomImageList_GetHeight, Fake);
  RegisterMethod(TCustomImageList, 'procedure SetHeight(Value: Integer);',
                @TCustomImageList_SetHeight, Fake);
  RegisterProperty(TCustomImageList, 'property Height: Integer read GetHeight'
                +' write SetHeight;');
  RegisterMethod(TCustomImageList, 'function GetWidth: Integer;',
                @TCustomImageList_GetWidth, Fake);
  RegisterMethod(TCustomImageList, 'procedure SetWidth(Value: Integer);',
                @TCustomImageList_SetWidth, Fake);
  RegisterProperty(TCustomImageList, 'property Width: Integer read GetWidth write'
                +' SetWidth;');
end.
