// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'BASE_SCANNER.pas' rev: 5.00

#ifndef BASE_SCANNERHPP
#define BASE_SCANNERHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <BASE_SYS.hpp>	// Pascal unit
#include <BASE_CONSTS.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Base_scanner
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TScannerState { scanText, scanProg };
#pragma option pop

class DELPHICLASS TDefRec;
class PASCALIMPLEMENTATION TDefRec : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	int Word;
	AnsiString What;
	bool Vis;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TDefRec(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TDefRec(void) { }
	#pragma option pop
	
};


class DELPHICLASS TDefStack;
class PASCALIMPLEMENTATION TDefStack : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* fItems;
	TDefRec* __fastcall GetItem(int I);
	
public:
	__fastcall TDefStack(void);
	__fastcall virtual ~TDefStack(void);
	void __fastcall Clear(void);
	int __fastcall Count(void);
	void __fastcall Push(int Word, AnsiString What, bool Vis);
	void __fastcall Pop(void);
	__property TDefRec* Items[int I] = {read=GetItem/*, default*/};
};


class DELPHICLASS TScannerRec;
class PASCALIMPLEMENTATION TScannerRec : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	int LineNumber;
	int PosNumber;
	char c;
	int P;
	AnsiString Buff;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TScannerRec(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TScannerRec(void) { }
	#pragma option pop
	
};


class DELPHICLASS TScannerStack;
class DELPHICLASS TPAXScanner;
class PASCALIMPLEMENTATION TScannerStack : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* fItems;
	TScannerRec* __fastcall GetItem(int I);
	
public:
	__fastcall TScannerStack(void);
	__fastcall virtual ~TScannerStack(void);
	void __fastcall Clear(void);
	int __fastcall Count(void);
	void __fastcall Push(TPAXScanner* Scanner);
	void __fastcall Pop(TPAXScanner* Scanner);
	__property TScannerRec* Items[int I] = {read=GetItem/*, default*/};
};


class PASCALIMPLEMENTATION TPAXScanner : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	void *Scripter;
	TScannerState fScannerState;
	void *Parser;
	void __fastcall SetSourceCode(const AnsiString Value);
	AnsiString __fastcall GetSourceCode();
	void __fastcall SetScannerState(TScannerState Value);
	
public:
	int LineNumber;
	int PosNumber;
	Base_sys::TPAXToken Token;
	Base_sys::TPAXToken BuffToken;
	char c;
	int P;
	AnsiString Buff;
	Classes::TStringList* VarNameList;
	TDefStack* DefStack;
	TScannerStack* ScannerStack;
	bool LookForward;
	__fastcall TPAXScanner(void * Parser);
	__fastcall virtual ~TPAXScanner(void);
	void __fastcall SetScripter(void * AScripter);
	void __fastcall Reset(void);
	bool __fastcall EndOfTagExpected(void);
	AnsiString __fastcall GetText(int P1, int P2);
	char __fastcall GetNextChar(void);
	char __fastcall LA(int N);
	virtual void __fastcall ReadToken(void);
	Base_sys::TPAXToken __fastcall NextToken();
	Base_sys::TPAXToken __fastcall Next2Token();
	void __fastcall ScanIdentifier(void);
	void __fastcall ScanChars(const Base_sys::TCharSet &CSet);
	void __fastcall ScanString(char ch);
	void __fastcall ScanHtmlString(const AnsiString Ch);
	void __fastcall ScanFormatString(void);
	void __fastcall ScanDigits(void);
	void __fastcall ScanHexDigits(void);
	void __fastcall ScanWhiteSpace(void);
	void __fastcall ScanEOF(void);
	void __fastcall ScanPlus(void);
	void __fastcall ScanMinus(void);
	void __fastcall ScanMult(void);
	void __fastcall ScanDiv(void);
	void __fastcall ScanMod(void);
	void __fastcall ScanGT(void);
	void __fastcall ScanLT(void);
	void __fastcall ScanEQ(void);
	void __fastcall ScanLeftRoundBracket(void);
	void __fastcall ScanRightRoundBracket(void);
	void __fastcall ScanLeftBracket(void);
	void __fastcall ScanRightBracket(void);
	void __fastcall ScanLeftBrace(void);
	void __fastcall ScanRightBrace(void);
	void __fastcall ScanColon(void);
	void __fastcall ScanSemiColon(void);
	void __fastcall ScanComma(void);
	void __fastcall ScanPoint(void);
	AnsiString __fastcall GetRegExpr();
	void __fastcall ScanCondDir(char Start1, const Base_sys::TCharSet &Start2);
	bool __fastcall IsEOF(void);
	void __fastcall IncLineNumber(void);
	__property AnsiString SourceCode = {read=GetSourceCode, write=SetSourceCode};
	__property TScannerState ScannerState = {read=fScannerState, write=SetScannerState, nodefault};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Base_scanner */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Base_scanner;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// BASE_SCANNER
